## cloop 2.6.28.2.1ubuntu1

=== Makefile ===
#!/usr/bin/make

MACHINE=$(shell uname -m)
KERNEL_DIR=/usr/src/linux

file_exist=$(shell test -f $(1) && echo yes || echo no)

# test for 2.6 or 2.4 kernel
ifeq ($(call file_exist,$(KERNEL_DIR)/Rules.make), yes)
PATCHLEVEL:=4
else
PATCHLEVEL:=6
endif

ifdef APPSONLY
CFLAGS:=-Wall -Wstrict-prototypes -Wno-trigraphs -O2 -s -I. -fno-strict-aliasing -fno-common -fomit-frame-pointer 
endif

KERNOBJ:=compressed_loop.o

# Name of module
ifeq ($(PATCHLEVEL),6)
MODULE:=cloop.ko
else
MODULE:=cloop.o
endif

ALL_TARGETS = create_compressed_fs extract_compressed_fs
ifndef APPSONLY
ALL_TARGETS += $(MODULE)
endif

all: $(ALL_TARGETS)

module: $(MODULE)

utils: create_compressed_fs extract_compressed_fs

# For Kernel 2.6, we now use the "recommended" way to build kernel modules
obj-m := cloop.o
cloop-objs := compressed_loop.o

$(MODULE): compressed_loop.c compressed_loop.h
	@echo "Building for Kernel Patchlevel $(PATCHLEVEL)"
	$(MAKE) modules -C $(KERNEL_DIR) M=$(CURDIR)

create_compressed_fs: advancecomp-1.15/advfs
	ln -f $< $@

advancecomp-1.15/advfs:
	( cd advancecomp-1.15 ; ./configure && $(MAKE) advfs )

extract_compressed_fs: extract_compressed_fs.c
	$(CC) -Wall -O2 -s -o $@ $< -lz

cloop_suspend: cloop_suspend.o
	$(CC) -o $@ $<

clean:
	rm -rf create_compressed_fs extract_compressed_fs zoom *.o *.ko Module.symvers .cloop* .compressed_loop.* .tmp* modules.order cloop.mod.c
	[ -f advancecomp-1.15/Makefile ] && $(MAKE) -C advancecomp-1.15 distclean || true

dist: clean
	cd .. ; \
	tar -cf - cloop/{Makefile,*.[ch],CHANGELOG,README} | \
	bzip2 -9 > $(HOME)/redhat/SOURCES/cloop.tar.bz2

compressed_loop.o create_compressed_fs.o: compressed_loop.h

=== debian/changelog ===
cloop (2.6.28.2.1ubuntu1) jaunty; urgency=low

  * Merge with Debian; remaining changes:
    - Do not build the cloop-src package.
    - Fix build failure with g++-4.3.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 08 Jan 2009 12:01:30 +0100

cloop (2.6.28.2.1) unstable; urgency=low

  * Big merge with version 2.628-2 from Knoppix sources
  * Moved Knoppix' changelog file to changelog.knoppix, delivered with another
    older CHANGELOG as a single upstream changelog file
  * Beautification of control and copyright files, dropped postrm

 -- Eduard Bloch <blade@debian.org>  Mon,  4 Dec 2006 00:11:52 +0100

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper. 
# GNU copyright 1997 by Joey Hess.
#
# This version is for a hypothetical package that builds an
# architecture-dependant package, as well as an architecture-independent
# package.

# Uncomment this to turn on verbose mode. 
#export DH_VERBOSE=1

SHELL=/bin/bash

PACKAGE=cloop-module
MA_DIR ?= /usr/share/modass
-include $(MA_DIR)/include/generic.mk
-include $(MA_DIR)/include/common-rules.mk

NCPUS := $(shell getconf _NPROCESSORS_ONLN 2>/dev/null || echo 1)

binary: binary-indep binary-arch

configure: configure-stamp
configure-stamp:
	dh_testdir
	touch configure-stamp

build: configure-stamp build-stamp
build-stamp:
	dh_testdir
	$(MAKE) -j$(NCPUS) utils
	touch build-stamp

# for m-a
kdist_clean: clean
kdist_config: kdist_configure
kdist_configure: prep-deb-files

binary-modules: kdist_configure
	$(MAKE) module KERNEL_DIR=$(KSRC)  KVERSION=$(KVERS)
	dh_installdirs -p $(PKGNAME) lib/modules/$(KVERS)/extra 
	cp *.ko $(CURDIR)/debian/$(PKGNAME)/lib/modules/$(KVERS)/extra 
	dh_testdir -a
	dh_testroot -a
	dh_installdebconf -a
	dh_installdocs -a README debian/README.Debian
	dh_installchangelogs CHANGELOG -a
	dh_compress -a
	dh_fixperms -a
	dh_installdeb -a
	dh_gencontrol -a -- -v$(VERSION)
	dh_md5sums -a
	dh_builddeb -a --destdir=$(DEB_DESTDIR)

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp
	$(MAKE) clean || true
	-dh_clean
	rm -rf debian/cloop-?.?.?* debian/cloop debian/cloop-module debian/cloop-module-?.?.* debian/*.files knoppix CHANGELOG_

install: DH_OPTIONS=
install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs -p cloop-utils usr/bin
	install -m 755 create_compressed_fs  $(CURDIR)/debian/cloop-utils/usr/bin/
#	install -m 755 advancecomp-1.9_create_compressed_fs/advfs  $(CURDIR)/debian/cloop-utils/usr/bin/
#	install -m 755 compressloop          $(CURDIR)/debian/cloop-utils/usr/bin/
	install -m 755 extract_compressed_fs $(CURDIR)/debian/cloop-utils/usr/bin/
	dh_installman -p cloop-utils $(CURDIR)/debian/create_compressed_fs.1
	cd $(CURDIR)/debian/cloop-utils/usr/share/man/man1 && ln -sf create_compressed_fs.1 extract_compressed_fs.1 && ln -sf create_compressed_fs.1 advfs.1
#	dh_installman $(CURDIR)/debian/compressloop.1
	cd debian/cloop-utils/usr/share/man/man1 && ln -s create_compressed_fs.1.gz extract_compressed_fs.1.gz

install-src: configure-stamp
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs -p cloop-src usr/src/modules/cloop
	echo $$UID
	tar -cf - {Makefile,*.[ch],debian/{po,compat,*template*,control*,copyright,rules,dirs,*_KVERS_*,README.Debian,changelog},README} | tar -x -C debian/cloop-src/usr/src/modules/cloop
	cat changelog.knoppix CHANGELOG > debian/cloop-src/usr/src/modules/cloop/CHANGELOG
	dh_fixperms -i
	cd debian/cloop-src/usr/src ; tar -cf - modules | bzip2 -9 > cloop.tar.bz2 ; rm -rf modules

binary-arch: build install build-deb

binary-indep: build-indep

build-deb:
	dh_testdir -a
	dh_testroot -a
	dh_installdebconf -a
	dh_installdocs -a README debian/README.Debian
	dh_installexamples -a cloop-node-control.sh
	cat changelog.knoppix  CHANGELOG > CHANGELOG_ && dh_installchangelogs CHANGELOG_ -a
	dh_strip -a
	dh_link -a
	dh_compress -a
	dh_fixperms -a
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

build-indep: configure-stamp
	dh_testdir -i
	dh_testroot -i
	dh_installdocs -i README debian/README.Debian
	dh_installexamples -i
	cat changelog.knoppix CHANGELOG > CHANGELOG_ && dh_installchangelogs CHANGELOG_ -i
	dh_strip -i
	dh_link -i
	dh_compress -i
	dh_fixperms -i
	dh_installdeb -i
	dh_shlibdeps -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

.PHONY: build clean binary-indep binary-arch binary kdist kdist_image kdist_configure kdist_clean kdist
.NOTPARALLEL:

## cloop 2.6.28.2.2ubuntu1

=== debian/changelog ===
cloop (2.6.28.2.2ubuntu1) karmic; urgency=low

  * Merge from Debian unstable, remaining changes:
    - Do not build the cloop-src package.
  * Dropped changes, superseded in Debian package:
    - Fix build failure with g++-4.3.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 03 Jun 2009 20:46:51 +0000

cloop (2.6.28.2.2) unstable; urgency=low

  * STL related fixes (using numeric_limits instead of INT_MAX, 
    closes: #521908) and minor compiler warning fixes in extract_compressed_fs.c
  * Changed default thread count to dynamic configuration, unless set by user
  * stop bothering about "too much data" with -s switch when the overall data
    size has hit the block boundaries

 -- Eduard Bloch <blade@debian.org>  Mon, 30 Mar 2009 23:38:12 +0200

=== debian/control ===
Source: cloop
Section: misc
Priority: optional
Maintainer: Ubuntu Core Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Eduard Bloch <blade@debian.org>
Build-Depends: debhelper (>> 5.0.0), zlib1g-dev, bzip2
Standards-Version: 3.7.2

Package: cloop-utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Tools for handling with cloop compressed volumes
 Utilities for creating and unpacking compressed loopback files
 for cloop.

## cloop 2.6.31.1.1

=== debian/changelog ===
cloop (2.6.31.1.1) unstable; urgency=low

  * Picked up relevant changes from upstream version 2.631-1
  * Updated config.{sub,guess} (closes: #535841)
  * added Spanish debconf translation from Shukoh (closes: #557002)

 -- Eduard Bloch <blade@debian.org>  Thu, 14 Jan 2010 22:28:22 +0100

=== debian/control ===
Source: cloop
Section: misc
Priority: optional
Maintainer: Eduard Bloch <blade@debian.org>
Build-Depends: debhelper (>> 5.0.0), zlib1g-dev, bzip2
Standards-Version: 3.8.3

Package: cloop-utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Tools for handling with cloop compressed volumes
 Utilities for creating and unpacking compressed loopback files
 for cloop.

Package: cloop-src
Architecture: all
Depends: module-assistant, debhelper (>= 5.0.37), bzip2, ${misc:Depends}
Suggests: linux-headers-2.6
Description: Source of the compressed loopback device module
 This package contains a source package for building the cloop module.
 You can use module-assistant or make-kpkg to build a modules package for
 specific kernel.

=== debian/rules ===
--- 
+++ 
@@ -22,6 +22,12 @@
 
 configure: configure-stamp
 configure-stamp:
+ifneq "$(wildcard /usr/share/misc/config.sub)" ""
+	cp -f /usr/share/misc/config.sub advancecomp-*/config.sub
+endif
+ifneq "$(wildcard /usr/share/misc/config.guess)" ""
+	cp -f /usr/share/misc/config.guess advancecomp-*/config.guess
+endif
 	dh_testdir
 	touch configure-stamp
 
@@ -88,7 +94,7 @@
 
 binary-arch: build install build-deb
 
-binary-indep: build-indep
+binary-indep: install-src build-indep
 
 build-deb:
 	dh_testdir -a
@@ -107,7 +113,7 @@
 	dh_md5sums -a
 	dh_builddeb -a
 
-build-indep: configure-stamp
+build-indep: configure-stamp install-src
 	dh_testdir -i
 	dh_testroot -i
 	dh_installdocs -i README debian/README.Debian

## cloop 2.6.31.1.1ubuntu1

=== debian/changelog ===
cloop (2.6.31.1.1ubuntu1) lucid; urgency=low

  * Merge from Debian testing, remaining changes:
    - Do not build the cloop-src package.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 27 Jan 2010 09:23:19 -0800

=== debian/control ===
Source: cloop
Section: misc
Priority: optional
Maintainer: Ubuntu Core Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Eduard Bloch <blade@debian.org>
Build-Depends: debhelper (>> 5.0.0), zlib1g-dev, bzip2
Standards-Version: 3.8.3

Package: cloop-utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Tools for handling with cloop compressed volumes
 Utilities for creating and unpacking compressed loopback files
 for cloop.

=== debian/rules ===
--- 
+++ 
@@ -94,7 +94,7 @@
 
 binary-arch: build install build-deb
 
-binary-indep: install-src build-indep
+binary-indep: build-indep
 
 build-deb:
 	dh_testdir -a
@@ -113,7 +113,7 @@
 	dh_md5sums -a
 	dh_builddeb -a
 
-build-indep: configure-stamp install-src
+build-indep: configure-stamp
 	dh_testdir -i
 	dh_testroot -i
 	dh_installdocs -i README debian/README.Debian

## cloop 2.6.39.2

=== Makefile ===
--- 
+++ 
@@ -1,7 +1,9 @@
 #!/usr/bin/make
 
 MACHINE=$(shell uname -m)
-KERNEL_DIR=/usr/src/linux
+ifndef KERNEL_DIR
+KERNEL_DIR:=/lib/modules/`uname -r`/build
+endif
 
 file_exist=$(shell test -f $(1) && echo yes || echo no)
 
@@ -16,7 +18,7 @@
 CFLAGS:=-Wall -Wstrict-prototypes -Wno-trigraphs -O2 -s -I. -fno-strict-aliasing -fno-common -fomit-frame-pointer 
 endif
 
-KERNOBJ:=compressed_loop.o
+KERNOBJ:=cloop.o
 
 # Name of module
 ifeq ($(PATCHLEVEL),6)
@@ -38,9 +40,9 @@
 
 # For Kernel 2.6, we now use the "recommended" way to build kernel modules
 obj-m := cloop.o
-cloop-objs := compressed_loop.o
+# cloop-objs := cloop.o
 
-$(MODULE): compressed_loop.c compressed_loop.h
+$(MODULE): cloop.c cloop.h
 	@echo "Building for Kernel Patchlevel $(PATCHLEVEL)"
 	$(MAKE) modules -C $(KERNEL_DIR) M=$(CURDIR)
 
@@ -54,15 +56,13 @@
 	$(CC) -Wall -O2 -s -o $@ $< -lz
 
 cloop_suspend: cloop_suspend.o
-	$(CC) -o $@ $<
+	$(CC) -Wall -O2 -s -o $@ $<
 
 clean:
-	rm -rf create_compressed_fs extract_compressed_fs zoom *.o *.ko Module.symvers .cloop* .compressed_loop.* .tmp* modules.order cloop.mod.c
+	rm -rf create_compressed_fs extract_compressed_fs zoom *.o *.ko Module.symvers .cloop* .compressed_loop.* .tmp*
 	[ -f advancecomp-1.15/Makefile ] && $(MAKE) -C advancecomp-1.15 distclean || true
 
 dist: clean
 	cd .. ; \
 	tar -cf - cloop/{Makefile,*.[ch],CHANGELOG,README} | \
 	bzip2 -9 > $(HOME)/redhat/SOURCES/cloop.tar.bz2
-
-compressed_loop.o create_compressed_fs.o: compressed_loop.h

=== debian/cloop-source/usr/src/modules/cloop/Makefile ===
#!/usr/bin/make

MACHINE=$(shell uname -m)
ifndef KERNEL_DIR
KERNEL_DIR:=/lib/modules/`uname -r`/build
endif

file_exist=$(shell test -f $(1) && echo yes || echo no)

# test for 2.6 or 2.4 kernel
ifeq ($(call file_exist,$(KERNEL_DIR)/Rules.make), yes)
PATCHLEVEL:=4
else
PATCHLEVEL:=6
endif

ifdef APPSONLY
CFLAGS:=-Wall -Wstrict-prototypes -Wno-trigraphs -O2 -s -I. -fno-strict-aliasing -fno-common -fomit-frame-pointer 
endif

KERNOBJ:=compressed_loop.o

# Name of module
ifeq ($(PATCHLEVEL),6)
MODULE:=cloop.ko
else
MODULE:=cloop.o
endif

ALL_TARGETS = create_compressed_fs extract_compressed_fs
ifndef APPSONLY
ALL_TARGETS += $(MODULE)
endif

all: $(ALL_TARGETS)

module: $(MODULE)

utils: create_compressed_fs extract_compressed_fs

# For Kernel 2.6, we now use the "recommended" way to build kernel modules
obj-m := cloop.o
cloop-objs := compressed_loop.o

$(MODULE): compressed_loop.c compressed_loop.h
	@echo "Building for Kernel Patchlevel $(PATCHLEVEL)"
	$(MAKE) modules -C $(KERNEL_DIR) M=$(CURDIR)

create_compressed_fs: advancecomp-1.15/advfs
	ln -f $< $@

advancecomp-1.15/advfs:
	( cd advancecomp-1.15 ; ./configure && $(MAKE) advfs )

extract_compressed_fs: extract_compressed_fs.c
	$(CC) -Wall -O2 -s -o $@ $< -lz

cloop_suspend: cloop_suspend.o
	$(CC) -Wall -O2 -s -o $@ $<

clean:
	rm -rf create_compressed_fs extract_compressed_fs zoom *.o *.ko Module.symvers .cloop* .compressed_loop.* .tmp*
	[ -f advancecomp-1.15/Makefile ] && $(MAKE) -C advancecomp-1.15 distclean || true

dist: clean
	cd .. ; \
	tar -cf - cloop/{Makefile,*.[ch],CHANGELOG,README} | \
	bzip2 -9 > $(HOME)/redhat/SOURCES/cloop.tar.bz2

compressed_loop.o create_compressed_fs.o: compressed_loop.h

=== debian/changelog ===
cloop (2.6.39.2-1ubuntu3) saucy; urgency=low

  * Regenerate the autotools patch to support AArch64.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 10 Oct 2013 13:23:06 +0200

cloop (2.6.39.2-1ubuntu2) quantal; urgency=low

  * Rebuild for new armel compiler default of ARMv5t.

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 01 Oct 2012 20:56:20 +0100

cloop (2.6.39.2-1ubuntu1) precise; urgency=low

  * Merge from Debian testing, remaining changes:
    - Do not build the cloop-src package.
  * Add Pre-Depends on dpkg (>= 1.15.6~) since we're using xz compression.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 02 Jan 2012 22:52:50 -0800

cloop (2.6.39.2-1) unstable; urgency=low

  * Imported new upstream version (closes: 436090, 632603)
  * Converted Debian source format to 3.0 (quilt), also using xz where possible
  * Move linux-headers-2.6 dependency to linux-headers (closes: 628872)
  * Merged extra changelog.knoppix file (documenting Knopper's branch changes)
    into common debian/changelog file, dropped the build time merging mess
  * Danish translation of the debconf templates from Joe Dalton (closes: 627713)
  * Korean translation of the debconf templates from 임영재 (closes: 632291)
 
 -- Eduard Bloch <blade@debian.org>  Mon, 12 Dec 2011 23:40:53 +0100

cloop (2.639-2) unstable; urgency=low

  * Change compressed_loop.h -> cloop.h everywhere.

 -- Klaus Knopper <knoppix@knopper.net>  Wed, 06 Jul 2011 18:43:20 +0200

cloop (2.639-1) unstable; urgency=low

  * Changes for kernel 2.6.39, replace lock_kernel() by mutex_lock()

 -- Klaus Knopper <knoppix@knopper.net>  Tue, 10 May 2011 14:18:21 +0200

cloop (2.637-1) unstable; urgency=low

  * Add compat_ioctl for compilation in 64bit mode.

 -- Klaus Knopper <knoppix@knopper.net>  Tue, 11 Jan 2011 22:57:31 +0100

cloop (2.636-1) unstable; urgency=low

  * Changes for new kernel 2.6.36 removed block layer api function and
    locked_ioctl.

 -- Klaus Knopper <knoppix@knopper.net>  Mon, 25 Oct 2010 22:40:25 +0200

cloop (2.634-1) unstable; urgency=low

  * Changes for new kernel 2.6.34 sector limit functions
  * Set device read-only by default

 -- Klaus Knopper <knoppix@knopper.net>  Wed, 25 Aug 2010 13:36:01 +0200

cloop (2.628-2) unstable; urgency=low

  * Reflect kernel 2.6.28 block device API changes in order to actually work.

 -- Klaus Knopper <knoppix@knopper.net>  Tue, 04 Nov 2008 18:38:02 +0100

cloop (2.628-1) unstable; urgency=low

  *  Minor source modifications for compiling with kernel 2.6.28

 -- Klaus Knopper <knoppix@knopper.net>  Sat, 25 Oct 2008 23:11:39 +0200

cloop (2.625-1) unstable; urgency=low

  * Kernel 2.6.25/26 api changes

 -- Klaus Knopper <knoppix@knopper.net>  Mon, 19 May 2008 18:44:27 +0200

cloop (2.624-1) unstable; urgency=low

  * Kernel 2.6.24 api change (rq_for_each_segment)

 -- Klaus Knopper <knoppix@knopper.net>  Sat, 26 Jan 2008 13:05:45 +0100

cloop (2.623-1) unstable; urgency=low

  * Fixed alloc_disk-leak (caused modprobe cloop; rmmod cloop; modprobe cloop to fail).
  * Added support for busybox losetup.

 -- Klaus Knopper <knoppix@knopper.net>  Sun, 16 Dec 2007 23:10:01 +0200

cloop (2.622-1) unstable; urgency=low

  * Rewrite with Kernel-Thread and request-queue for Kernel 2.6.22 and up.
  * Abandoned Kernel 2.4 support.
  * Replaced obsolete advancecomp-1.9 by 1.15

 -- Klaus Knopper <knoppix@knopper.net>  Sun, 23 Sep 2007 22:19:05 +0200

cloop (2.06-2) unstable; urgency=low

  * Patch for Kernel 2.6.22 invalidate_bdev(one arg).

 -- Klaus Knopper <knoppix@knopper.net>  Tue, 10 Jul 2007 06:16:26 +0200

cloop (2.06-1) unstable; urgency=low

  * Added "cloop_suspend" ioctl and utility contributed by Fabian Franz.

 -- Klaus Knopper <knoppix@knopper.net>  Sun, 25 Feb 2007 22:25:52 +0100

cloop (2.05-1) unstable; urgency=low

  * Adopted Eduard Blochs debian buildscripts for generic cloop 2.05

 -- Klaus Knopper <knoppix@knopper.net>  Sun, 20 Aug 2006 14:10:24 +0200

=== debian/control ===
Source: cloop
Section: misc
Priority: optional
Maintainer: Ubuntu Core Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Eduard Bloch <blade@debian.org>
Build-Depends: debhelper (>> 5.0.0), zlib1g-dev, bzip2, xz-utils
Standards-Version: 3.9.2

Package: cloop-utils
Architecture: any
Pre-Depends: dpkg (>= 1.15.6~)
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Tools for handling with cloop compressed volumes
 Utilities for creating and unpacking compressed loopback files
 for cloop.

=== debian/rules ===
--- 
+++ 
@@ -16,7 +16,10 @@
 -include $(MA_DIR)/include/generic.mk
 -include $(MA_DIR)/include/common-rules.mk
 
-NCPUS := $(shell getconf _NPROCESSORS_ONLN 2>/dev/null || echo 1)
+PARJOBS=-j2
+ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
+PARJOBS = -j$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
+endif
 
 binary: binary-indep binary-arch
 
@@ -34,7 +37,7 @@
 build: configure-stamp build-stamp
 build-stamp:
 	dh_testdir
-	$(MAKE) -j$(NCPUS) utils
+	$(MAKE) $(PARJOBS) utils
 	touch build-stamp
 
 # for m-a
@@ -64,7 +67,7 @@
 	rm -f build-stamp configure-stamp
 	$(MAKE) clean || true
 	-dh_clean
-	rm -rf debian/cloop-?.?.?* debian/cloop debian/cloop-module debian/cloop-module-?.?.* debian/*.files knoppix CHANGELOG_
+	rm -rf debian/cloop-?.?.?* debian/cloop debian/cloop-module debian/cloop-module-?.?.* debian/*.files knoppix
 
 install: DH_OPTIONS=
 install: build
@@ -86,9 +89,8 @@
 	dh_testroot
 	dh_clean -k
 	dh_installdirs -p cloop-src usr/src/modules/cloop
-	echo $$UID
 	tar -cf - {Makefile,*.[ch],debian/{po,compat,*template*,control*,copyright,rules,dirs,*_KVERS_*,README.Debian,changelog},README} | tar -x -C debian/cloop-src/usr/src/modules/cloop
-	cat changelog.knoppix CHANGELOG > debian/cloop-src/usr/src/modules/cloop/CHANGELOG
+	cp CHANGELOG debian/cloop-src/usr/src/modules/cloop/CHANGELOG
 	dh_fixperms -i
 	cd debian/cloop-src/usr/src ; tar -cf - modules | bzip2 -9 > cloop.tar.bz2 ; rm -rf modules
 
@@ -102,7 +104,7 @@
 	dh_installdebconf -a
 	dh_installdocs -a README debian/README.Debian
 	dh_installexamples -a cloop-node-control.sh
-	cat changelog.knoppix  CHANGELOG > CHANGELOG_ && dh_installchangelogs CHANGELOG_ -a
+	dh_installchangelogs CHANGELOG -a
 	dh_strip -a
 	dh_link -a
 	dh_compress -a
@@ -111,14 +113,14 @@
 	dh_shlibdeps -a
 	dh_gencontrol -a
 	dh_md5sums -a
-	dh_builddeb -a
+	dh_builddeb -a -- -Zxz
 
 build-indep: configure-stamp
 	dh_testdir -i
 	dh_testroot -i
 	dh_installdocs -i README debian/README.Debian
 	dh_installexamples -i
-	cat changelog.knoppix CHANGELOG > CHANGELOG_ && dh_installchangelogs CHANGELOG_ -i
+	dh_installchangelogs CHANGELOG -i
 	dh_strip -i
 	dh_link -i
 	dh_compress -i
@@ -127,7 +129,7 @@
 	dh_shlibdeps -i
 	dh_gencontrol -i
 	dh_md5sums -i
-	dh_builddeb -i
+	dh_builddeb -i -- -Zxz
 
 .PHONY: build clean binary-indep binary-arch binary kdist kdist_image kdist_configure kdist_clean kdist
 .NOTPARALLEL:

## cloop 3.14.1.1

=== debian/changelog ===
cloop (3.14.1.1) unstable; urgency=medium

  * Fixes build failure (old bashism)
  * Passing some configure flags to embedded compressor implementation
  * Bugfix in create_compressed_fs (fallout from previous change)
  * Restored support for kernel versions >= 3.11
  * Moved README.md (is just text) to README as hard copy, not symlink

 -- Eduard Bloch <blade@debian.org>  Sat, 25 Oct 2014 11:48:40 +0200

cloop (3.14.1) unstable; urgency=medium

  * New upstream version
    + updated version, works with kernel versions 3.14..3.17 (closes: #719128)
  * New location, now originating on Klaus Knopper's github version
  * Changed package package type to native until the mode of cooperation with
    upstream is fully clarified
  * Overhaul of debian packaging, changed to dh(7) style, auto-updating
    autotools-dev files on build now (closes: #727288)
  * Enabled hardening, fixed some minor issues in advfs.cc
  * Removed special hacks for ancient Cygwin and Mac OS X versions in
    extract_compressed_fs.c (closes: #370204)
  * Italian translation of debconf messages from Beatrice Torracca
    (closes: #714004)

 -- Eduard Bloch <blade@debian.org>  Sat, 25 Oct 2014 00:08:27 +0200

cloop (3.14-1) unstable; urgency=medium

  * Updates for Kernel >= 3.14
  * Preparing for git repository upload

 -- Klaus Knopper <knoppix@knopper.net>  Tue, 26 Aug 2014 17:14:37 +0200

## cloop 3.14.1.2

=== debian/changelog ===
cloop (3.14.1.2) unstable; urgency=low

  * Fix the build with kernel 3.19+ (f_dentry macro removal)

 -- Eduard Bloch <blade@debian.org>  Sun, 03 May 2015 13:15:58 +0200

=== debian/control ===
Source: cloop
Section: misc
Priority: optional
Maintainer: Eduard Bloch <blade@debian.org>
Build-Depends: debhelper (>> 9), zlib1g-dev, xz-utils, autotools-dev
Standards-Version: 3.9.6

Package: cloop-utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Tools for handling with cloop compressed volumes
 Utilities for creating and unpacking compressed loopback files
 for cloop.

Package: cloop-src
Architecture: all
Depends: module-assistant, debhelper (>= 5.0.37), xz-utils, ${misc:Depends}
Description: Source of the compressed loopback device module
 This package contains a source package for building the cloop module.
 You can use module-assistant or make-kpkg to build a modules package for
 specific kernel.

## cloop 3.14.1.2b1

=== debian/changelog ===
cloop (3.14.1.2b1) staging; urgency=high

  * No-change rebuild against libstdc++6

 -- Philip Muškovac <yofel@kubuntu.org>  Thu, 27 Aug 2015 23:08:24 +0000

## cloop 3.14.1.2ubuntu1

=== debian/changelog ===
cloop (3.14.1.2ubuntu1) xenial; urgency=medium

  * Merge with Debian; remaining changes:
    - Do not build the cloop-src package.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 07 Jan 2016 11:17:59 +0100

=== debian/control ===
Source: cloop
Section: misc
Priority: optional
Maintainer: Ubuntu Core Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Eduard Bloch <blade@debian.org>
Build-Depends: debhelper (>> 9), zlib1g-dev, xz-utils, autotools-dev
Standards-Version: 3.9.6

Package: cloop-utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Tools for handling with cloop compressed volumes
 Utilities for creating and unpacking compressed loopback files
 for cloop.

## cloop 3.14.1.2ubuntu2

=== debian/changelog ===
cloop (3.14.1.2ubuntu2) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 22 Mar 2020 16:36:16 +0100

## cloop 3.14.1.2ubuntu3

=== debian/changelog ===
cloop (3.14.1.2ubuntu3) focal; urgency=medium

  * extract_compressed_fs.c: Define _DEFAULT_SOURCE to fix FTBFS with glibc
    2.28+ due to loff_t only being defined when that macro is defined.

 -- Logan Rosen <logan@ubuntu.com>  Mon, 06 Apr 2020 22:15:53 -0400

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: cloop
 Section: misc
 Priority: optional
-Maintainer: Ubuntu Core Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Eduard Bloch <blade@debian.org>
 Build-Depends: debhelper (>> 9), zlib1g-dev, xz-utils, autotools-dev
 Standards-Version: 3.9.6

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/architecture.mk
CFLAGS += -flto
CXXFLAGS += -flto
LDFLAGS += -flto

XDIR=debian/cloop-src/usr/src/modules/cloop

%:
	dh $@ --parallel --with autotools_dev

override_dh_auto_configure:
	cd advancecomp-1.15 && ./configure --host=$(DEB_HOST_GNU_TYPE) --build=$(DEB_BUILD_GNU_TYPE)

# compile just the tools, not the kernel module
override_dh_auto_build:
	dh_auto_build -- extract_compressed_fs
	dh_auto_build -- -C advancecomp-1.15 advfs
	dh_auto_build -- extract_compressed_fs create_compressed_fs

override_dh_auto_install:
	install -d $(XDIR)/debian debian/cloop-utils/usr/bin debian/cloop-utils/usr/share/doc/cloop-utils
	install -m 755 create_compressed_fs extract_compressed_fs  debian/cloop-utils/usr/bin/
	cp Makefile *.c *.h README ChangeLog $(XDIR)
	cd debian && install rules.m-a ../$(XDIR)/debian/rules && cp -r po compat control* copyright *_KVERS_* README.Debian changelog ../$(XDIR)/debian
	dh_fixperms -i -Xrules
	cd debian/cloop-src/usr/src && XZ_OPT=-9 tar --xz -c -f cloop.tar.xz modules && rm -rf modules

## cloop 3.14.1.3

=== debian/changelog ===
cloop (3.14.1.3) unstable; urgency=medium

  * Upgrading to more recent debhelper and latest policy standards
  * Upgrading cloop kernel driver to version 5.3 (snapshot from KNOPPIX kernel
    5.4.16-64, thanks to Klaus Knopper)
  * Cherry-picked FTBFS fix from 3.14.1.2ubuntu3 (see below), keeping the
    cloop-src package build enabled (closes: #916049)

  [ Logan Rosen <logan@ubuntu.com> ]
  * extract_compressed_fs.c: Define _DEFAULT_SOURCE to fix FTBFS with glibc
    2.28+ due to loff_t only being defined when that macro is defined.

 -- Eduard Bloch <blade@debian.org>  Sun, 19 Apr 2020 10:18:13 +0200

=== debian/control ===
Source: cloop
Section: misc
Priority: optional
Maintainer: Eduard Bloch <blade@debian.org>
Build-Depends: debhelper (>> 10), zlib1g-dev, xz-utils
Standards-Version: 4.5.0
Vcs-Git: https://github.com/Code7R/cloop.git -b debian/sid

Package: cloop-utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Tools for handling with cloop compressed volumes
 Utilities for creating and unpacking compressed loopback files
 for cloop.

Package: cloop-src
Architecture: all
Depends: module-assistant, debhelper (>= 5.0.37), xz-utils, ${misc:Depends}
Description: Source of the compressed loopback device module
 This package contains a source package for building the cloop module.
 You can use module-assistant or make-kpkg to build a modules package for
 specific kernel.

=== debian/rules ===
--- 
+++ 
@@ -11,7 +11,7 @@
 XDIR=debian/cloop-src/usr/src/modules/cloop
 
 %:
-	dh $@ --parallel --with autotools_dev
+	dh $@
 
 override_dh_auto_configure:
 	cd advancecomp-1.15 && ./configure --host=$(DEB_HOST_GNU_TYPE) --build=$(DEB_BUILD_GNU_TYPE)

## cloop 3.14.1.3+nmu1

=== Makefile ===
--- 
+++ 
@@ -38,7 +38,7 @@
 
 utils: create_compressed_fs extract_compressed_fs
 
-# For Kernel 2.6, we now use the "recommended" way to build kernel modules
+# For Kernel >= 2.6, we now use the "recommended" way to build kernel modules
 obj-m := cloop.o
 # cloop-objs := cloop.o
 
@@ -53,16 +53,17 @@
 	( cd advancecomp-1.15 ; ./configure && $(MAKE) advfs )
 
 extract_compressed_fs: extract_compressed_fs.c
-	$(CC) -Wall -O2 -s -o $@ $< -lz
+	$(CC) -Wall -O2 $(CFLAGS) $(LDFLAGS) -o $@ $< -lz
 
 cloop_suspend: cloop_suspend.o
 	$(CC) -Wall -O2 -s -o $@ $<
 
 clean:
-	rm -rf create_compressed_fs extract_compressed_fs zoom *.o *.ko Module.symvers .cloop* .compressed_loop.* .tmp*
+	rm -rf create_compressed_fs extract_compressed_fs zoom *.o *.ko Module.symvers .cloop* .compressed_loop.* .tmp* modules.order cloop.mod.c
 	[ -f advancecomp-1.15/Makefile ] && $(MAKE) -C advancecomp-1.15 distclean || true
 
 dist: clean
 	cd .. ; \
 	tar -cf - cloop/{Makefile,*.[ch],CHANGELOG,README} | \
 	bzip2 -9 > $(HOME)/redhat/SOURCES/cloop.tar.bz2
+

=== debian/changelog ===
cloop (3.14.1.3+nmu1) unstable; urgency=medium

  * Non-maintainer upload

  [ Ben Hutchings ]
  * Fix FTBFS with gcc 11 (Closes: #1005413):
    - Remove exception specifications
  * Fix module build for recent kernel versions (Closes: #1005414):
    - Stop generating module vermagic in cloop.c. This has always been handled
      by modpost and doing it here now results in build failure.
    - Avoid using inode::i_bdev, which was removed in Linux 5.11.
    - Use set_disk_ro() instead of set_device_ro(). The latter was not meant to
      be used by device drivers and was removed in Linux 5.11.
    - Use blk_{mq_alloc,cleanup}_disk() instead of separate queue and disk
      allocation and cleanup on Linux 5.15+, since alloc_disk() was removed.
    - Handle potential failure of add_disk() on Linux 5.15+.
    - Use kernel_read() instead of vfs_read() and set_fs(). set_fs() is no
      longer defined on some architectures, and kernel_read() has had large
      file support since Linux 2.6.31.

  [ Vagrant Cascadian ]
  * debian/rules: Build tarball reproducibly, using consistent time, uid,
    gid and sort order. Thanks to Dhole for the initial patch.
    (Closes: #787996)

 -- Vagrant Cascadian <vagrant@reproducible-builds.org>  Thu, 22 Dec 2022 12:41:49 -0800

=== debian/rules ===
--- 
+++ 
@@ -28,4 +28,4 @@
 	cp Makefile *.c *.h README ChangeLog $(XDIR)
 	cd debian && install rules.m-a ../$(XDIR)/debian/rules && cp -r po compat control* copyright *_KVERS_* README.Debian changelog ../$(XDIR)/debian
 	dh_fixperms -i -Xrules
-	cd debian/cloop-src/usr/src && XZ_OPT=-9 tar --xz -c -f cloop.tar.xz modules && rm -rf modules
+	cd debian/cloop-src/usr/src && XZ_OPT=-9 tar --xz --sort=name --mtime=@$(SOURCE_DATE_EPOCH) --owner=0 --group=0 --numeric-owner  -c -f cloop.tar.xz modules && rm -rf modules

## cloop 3.14.1.3+nmu1build1

=== debian/changelog ===
cloop (3.14.1.3+nmu1build1) resolute; urgency=medium

  * No-change mass rebuild for Ubuntu 26.04 (LP: #2132257)

 -- Graham Inggs <ginggs@ubuntu.com>  Wed, 10 Dec 2025 20:55:44 +0000
